/**
 * @file aufgabe01.cpp
 * @author Gießel, Franjo (Franjo.Giessel@smail.HS-Bremerhaven.de)
 * @brief Zwei Zahlen a und b können dadurch multipliziert werden, dass eine Schleife 
 * von 0 bis b-1 läuft und immer wieder zum Ergebnis a hinzuaddiert. 
 * Implementieren Sie eine Methode mult_iter, die dieses Verfahren iterativ 
 * implementiert und eine Methode mult_rec, die dieses Verfahren rekursiv 
 * implementiert. Beachten Sie, dass a und b auch jeweils negativ sein können.
 * @version 0.1
 * @date 2022-05-02
 * 
 * @copyright Copyright (c) 2022
 */

#include <iostream>

using namespace std;

int mult_iter(int a, int b) {
    int erg = 0;
    b = a < 0 ? -b : b; // wenn a negativ ist, b nigieren
    a = a < 0 ? -a : a; // wenn a negativ ist, a nigieren
    for (int i = 0; i < a; ++i) {
        erg = erg + b;
    }
    return erg;
}

int mult_rec(int a, int b) {
    if (a == 0) {
        return 0;
    } else if (a > 0) {
        return mult_rec(a-1, b) + b;
    } else {
        return mult_rec(a+1, b) - b;
    }
}

void test(int i, int j) {
    cout << "mult_iter(" << i << ", " << j << ") = " << mult_iter(i, j) << endl;
    cout << "mult_rec(" << i << ", " << j << ") = " << mult_rec(i, j) << endl << endl;

    cout << "mult_iter(" << -i << ", " << j << ") = " << mult_iter(-i, j) << endl;
    cout << "mult_rec(" << -i << ", " << j << ") = " << mult_rec(-i, j) << endl << endl;

    cout << "mult_iter(" << i << ", " << -j << ") = " << mult_iter(i, -j) << endl;
    cout << "mult_rec(" << i << ", " << -j << ") = " << mult_rec(i, -j) << endl << endl;

    cout << "mult_iter(" << -i << ", " << -j << ") = " << mult_iter(-i, -j) << endl;
    cout << "mult_rec(" << -i << ", " << -j << ") = " << mult_rec(-i, -j) << endl << endl;

    cout << "mult_iter(" << 0 << ", " << j << ") = " << mult_iter(0, j) << endl;
    cout << "mult_rec(" << 0 << ", " << j << ") = " << mult_rec(0, j) << endl << endl;

    cout << "mult_iter(" << i << ", " << 0 << ") = " << mult_iter(i, 0) << endl;
    cout << "mult_rec(" << i << ", " << 0 << ") = " << mult_rec(i, 0) << endl << endl;

    cout << "mult_iter(" << 0 << ", " << j << ") = " << mult_iter(0, -j) << endl;
    cout << "mult_rec(" << 0 << ", " << -j << ") = " << mult_rec(0, -j) << endl << endl;

    cout << "mult_iter(" << -i << ", " << 0 << ") = " << mult_iter(-i, 0) << endl;
    cout << "mult_rec(" << -i << ", " << 0 << ") = " << mult_rec(-i, 0) << endl << endl;
} 

int main() {
    int i, j;
    cout << "Zahl 1: ";
    cin >> i;
    cout << "Zahl 2: ";
    cin >> j;

    cout << "mult_iter(" << i << ", " << j << ") = " << mult_iter(i, j) << endl;
    cout << "mult_rec(" << i << ", " << j << ") = " << mult_rec(i, j) << endl;

    //test(i, j);
    return 0;
} 