/**
 * @file aufgabe02.cpp
 * @author Gießel, Franjo (Franjo.Giessel@smail.HS-Bremerhaven.de)
 * @brief Implementieren Sie in die Türme von Hanoi (ohne Klassen, nur mit Text auf 
 * dem Konsolenfenster wie in Prog I „Hanoi2“ Lösung, bei der die Türme als 
 * Blockgrafik ausgegeben werden). 
 * @version 0.1
 * @date 2022-05-02
 * 
 * @copyright Copyright (c) 2022
 */

#include <iostream>
using namespace std;

const unsigned numberTowers = 3;
const unsigned heightTowers = 5;


void init(unsigned towers[][heightTowers]) {
    // geprüft

    // cout << sizeof(towers) << endl;
    // cout << sizeof(towers[0]) << endl;
    // cout << (numberTowers) << endl;

    for (unsigned i = 0; i < (numberTowers); ++i) {
        for (unsigned j = 0; j < (heightTowers); ++j) {
            towers[i][j] = i==0 ? 2*j + 1 : 0;
        }
    }
}

/**
 * @brief Bewegt den obersten Stein des Turms iFrom zum Turm iTo. 
 * Dabei wird nicht geprüft, ob der Zug legal ist.
 * 
 * @param iFrom Tower ID woher
 * @param iTo Tower ID wohin
 */
void moveStone (unsigned towers[][heightTowers], unsigned iFrom, unsigned iTo) {
    // geprüft

    for (unsigned i = 0; i < (heightTowers); ++i) {
        if (towers[iFrom][i] != 0) {
            for (unsigned j = (heightTowers -1); true; --j) {
                if (towers[iTo][j] == 0) {
                    towers[iTo][j] = towers[iFrom][i];
                    towers[iFrom][i] = 0;
                    return;
                }
            }
        }
    }
}

/**
 * @brief Gibt einen Stone auf der Console aus.
 * 
 * @param iWidth Größe des Steins (iWidth <= 21)
 */
void printStone(unsigned iWidth) {
    // geprüft

    if (iWidth == 0) {
        for (unsigned i = 0; i < 21; ++i) {
            cout << " ";
        }
    } else {
        for (unsigned i = 0; i < (21 - iWidth) / 2; ++i) {
            cout << " ";
        }
        for (unsigned i = 0; i < iWidth; ++i) {
            cout << "+";
        }
        for (unsigned i = 0; i < (21 - iWidth) / 2; ++i) {
            cout << " ";
        }
    }
}

/**
 * @brief Gibt die Türme auf der Console aus.
 * 
 */
void printTowers(unsigned towers[][heightTowers]) {
    // geprüft

    for (unsigned j = 0; j < (heightTowers); ++j) {
        for (unsigned i = 0; i < (numberTowers); ++i) {
            printStone(towers[i][j]);
        }
        cout << endl;
    }
    cout << "------------------------------------------";
    cout << "------------------------------------------" << endl << endl;
}

/**
 * @brief Bewegt N Steine vom Turm iFrom über den Turm iVia zum Turm iTo.
 * 
 * @param N Anzahl Steine, die bewegt werden sollen
 * @param iFrom Tower ID woher
 * @param iTo  Tower ID wohin
 * @param iVia  Tower ID via Hilfsstange
 */
void move(unsigned towers[][heightTowers], unsigned N, unsigned iFrom, unsigned iTo, unsigned iVia) {
    // geprüft

    if (N > 0) {
        move(towers, N-1, iFrom, iVia, iTo);
        moveStone(towers, iFrom, iTo);
        printTowers(towers);
        move(towers, N-1, iVia, iTo, iFrom);
    }
}

int main() {
    // geprüft

    unsigned towers[numberTowers][heightTowers];
    // cout << sizeof(towers) << endl;
    // cout << sizeof(towers[0]) << endl;
    // cout << (numberTowers) << endl;
    init (towers);
    printTowers(towers);
    move(towers, heightTowers, 0, 2, 1);
    return 0; 
}