/**
 * @file aufgabe02.cpp
 * @author Gießel, Franjo (Franjo.Giessel@smail.HS-Bremerhaven.de)
 * @brief Implementieren Sie in die Türme von Hanoi (ohne Klassen, nur mit Text auf 
 * dem Konsolenfenster wie in Prog I „Hanoi2“ Lösung, bei der die Türme als 
 * Blockgrafik ausgegeben werden). 
 * @version 0.1
 * @date 2022-05-02
 * 
 * @copyright Copyright (c) 2022
 */

#include <iostream>
using namespace std;

const unsigned numberTowers = 3;
const unsigned heightTowers = 5;


void init(unsigned (&towers)[numberTowers][heightTowers]) {
    // geprüft

    // cout << sizeof(towers) << endl;
    // cout << sizeof(towers[0]) << endl;
    // cout << (sizeof(towers) / sizeof(towers[0])) << endl;

    for (unsigned i = 1; i < (sizeof(towers) / sizeof(towers[0])); ++i) {
        for (unsigned j = 0; j < (sizeof(towers[i]) / sizeof(unsigned)); ++j) {
            towers[i][j] = 0;
        }
    }
    for (unsigned i = 0; i < (sizeof(towers[0]) / sizeof(unsigned)); ++i) {
        towers[0][i] = 2*i + 1;
    }
}

void moveStone (unsigned (&towers)[numberTowers][heightTowers], unsigned iFrom, unsigned iTo) {
    // geprüft

    for (unsigned i = 0; i < (sizeof(towers[iFrom]) / sizeof(towers[iFrom][0])); ++i) {
        if (towers[iFrom][i] != 0) {
            for (unsigned j = (sizeof(towers[iTo]) / sizeof(towers[iTo][0])); j-- > 0;) {
                if (towers[iTo][j] == 0) {
                    towers[iTo][j] = towers[iFrom][i];
                    towers[iFrom][i] = 0;
                    return;
                }
            }
        }
    }
}

void printStone(unsigned iWidth) {
    // geprüft

    if (iWidth == 0) {
        for (unsigned i = 0; i < 21; ++i) {
            cout << " ";
        }
    } else {
        for (unsigned i = 0; i < (21 - iWidth) / 2; ++i) {
            cout << " ";
        }
        for (unsigned i = 0; i < iWidth; ++i) {
            cout << "+";
        }
        for (unsigned i = 0; i < (21 - iWidth) / 2; ++i) {
            cout << " ";
        }
    }
}

void printTowers(unsigned (&towers)[numberTowers][heightTowers]) {
    // geprüft

    for (unsigned j = 0; j < (sizeof(towers[0]) / sizeof(towers[0][0])); ++j) {
        for (unsigned i = 0; i < (sizeof(towers) / sizeof(towers[0])); ++i) {
            printStone(towers[i][j]);
        }
        cout << endl;
    }
    cout << "------------------------------------------";
    cout << "------------------------------------------" << endl << endl;
}

/**
 * @brief 
 * 
 * @param N wie viele Steine
 * @param iFrom Tower Nr. woher
 * @param iTo  Tower Nr. wohin
 * @param iVia  Tower Nr. via Hilfsstange
 */
void move(unsigned (&towers)[numberTowers][heightTowers], unsigned N, unsigned iFrom, unsigned iTo, unsigned iVia) {
    // geprüft

    if (N > 0) {
        move(towers, N-1, iFrom, iVia, iTo);
        moveStone(towers, iFrom, iTo);
        printTowers(towers);
        move(towers, N-1, iVia, iTo, iFrom);
    }
}

int main() {
    // geprüft

    unsigned towers[numberTowers][heightTowers];
    // cout << sizeof(towers) << endl;
    // cout << sizeof(towers[0]) << endl;
    // cout << (sizeof(towers) / sizeof(towers[0])) << endl;
    init (towers);
    printTowers(towers);
    move(towers, heightTowers, 0, 2, 1);
    return 0; 
}