package Uebung09;

/**
 * <h1>Übung 09, Aufgabe 02</h1>
 *
 * <p>Programmieren 1
 * Wintersemester 2021/-22
 * HS-Bremerhaven
 * Prof. Dr. Peter Kelb</p>
 *
 * <p>Scheiben Sie ein Java Programm, dass das 8 Dame Problem löst. Lösen Sie das
 * Problem rekursiv.</p>
 *
 * @author franjogiessel
 */
public class Aufgabe02 {
  
  /**
   * Überprüft, ob eine Queen an der Stelle qx, qy auf dem Schachbrett board legal gestellt werden kann.
   * @param board Repräsentation des Schachbretts als eindimensionales int-Array.
   * @param qx Zu prüfende X-Koordinate der Queen
   * @param qy Zu prüfende Y-Koordinate der Queen
   * @return Geprüfte Position ist legal.
   */
  public static boolean check(int[] board, int qx, int qy) {

    // ty = zu testendes y
    // board[ty] = zu testendes x
    // qy = y-Position der queen
    // qx = x-Position der queen
    for(int ty = 0; ty < board.length; ++ty) {

      if(board[ty] == qx) // Prüfe ober und unterhalb
        return false;

      if(board[ty] != -1 && ty-board[ty] == qy-qx) // prüfe diagonal links oben, rechts unten
        return false;

      if(board[ty] != -1 && ty+board[ty] == qy+qx) // prüfe diagonal links unten, rechts oben
        return false;
    }

    return true;
  }

  /**
   * Rekursive Implementation des Damenproblems.
   * @param board Repräsentation des Schachbretts als eindimensionales int-Array. 
   * Wert repräsentiert die x-Koordinate der Queen, -1 repräsentiert keine Queen
   * @param y Aktuelle zu prüfende y-Koordinate, sollte beginnend bei 0 starten.
   * @return Wurde eine korrekte Lösung gefunden, wird 0 returnt, ansonsten -1.
   */
  public static int queens(int[] board, int y) {

    if (y == board.length) {
        return 0;
    }

    for (int x = 0; board[y] == -1 && x < board.length; ++x) {
      if(check(board, x, y)) {
        board[y] = x;
        //System.out.println(y + " " + board[y]);
        if (queens(board,y + 1) == -1) {
            board[y] = -1;
        }
      }
    }
    return board[y] != -1 ? 0 : -1;
  }
    if (queens(board, y+1) == -1) {
                board[y] = -1;
            }
  /**
   * Gibt das Schachbrett auf der Console aus.
   * @param board Schachbrett, das ausgegeben werden soll.
   */
  public static void printBoard (int[] board) {
      for (int y = 0; y < board.length; ++y) {
        for (int x = 0; x < board.length; ++x) {
            System.out.print(x == board[y] ? "X " : "o ");
        }
        System.out.println();
      }
  }

  public static void main(String[] args) {

    int[] board = {-1, -1, -1, -1, -1, -1, -1, -1};
    int counter = queens(board, 0);
    System.out.println("Es gibt " + (counter != 0 ? "k" : "") + "eine Lösung!");
    printBoard(board);
  }
}