/**
 * @file aufgabe01.cpp
 * @author Gießel, Franjo (Franjo.Giessel@smail.HS-Bremerhaven.de)
 * @brief Schreiben Sie eine Methode, die solange Zeichen von der Tastatur einliest, bis ein Zeichen ungleich der Ziffern eingegeben wird. Das erste Zeichen darf aber auch das ‚–‘ Minus sein. Die Methode soll die Zahl errechnen, die aus der Reihenfolge der Ziffern besteht. Beispieleingabe: - 2 3 4 2 5, Ausgabe: die Zahl –23425.
 * @version 0.1
 * @date 2022-05-14
 *
 * @copyright Copyright (c) 2022
 */

#include <iostream>
using namespace std;

/**
 * @brief Ließt eine Zahl Zeichen für Zeichen über die Tastatur ein, bis ein Zeichen ungleich einer Zahl kommt. Das Erste Zeichen darf ein Minus sein.
 * 
 * @return int Eingelesene Zahl
 */
int readIntFromKeyboard() {
    char character;
    bool isNegative = false;
    int number = 0;
    do {
        cin >> character;

        if (character == '-' && number == 0 && !isNegative)  { // Eingegebenes Zeichen = '-', die Eingabe hat noch keinen Wert und ist noch nicht negativ
            isNegative = true;
        } else if ((character >= '0' && character <= '9')) { // Eingegebenes Zeichen zwischen '0' und '9'
            number = number * 10 + (character - '0');
        } else { // Ein illegales Zeichen wurde eingegeben
            return isNegative ? -number : number;
        }
    } while (true);
}

int main() {
    cout << "Bitte geben Sie Ihre Zahl ein. Nach jeder Ziffer bestätigen Sie bitte mit der Enter-Taste: ";
    int erg = readIntFromKeyboard();
    cout << "Die Zahl lautet: " << erg << endl;
    return 0;
}