/**
 * @file aufgabe01.cpp
 * @author Gießel, Franjo (Franjo.Giessel@smail.HS-Bremerhaven.de)
 * @brief Schreiben Sie die Funktion cat, die zwei Strings (char-Pointer) übergeben bekommt und einen neuen String (char Pointer) zurückliefert, der die Konkatenation der beiden enthält. Vermeiden Sie vordefinierten Funktionen wie strlen, cpy..
 * @version 0.1
 * @date 2022-05-21
 * 
 * @copyright Copyright (c) 2022
 * 
 */

#include <iostream>
using namespace std;

/**
 * @brief Get the length of the char-array.
 * 
 * @param str char-array
 * @return unsigned Length of the char-array
 */
unsigned getCharLength (char* str) {
    unsigned length = 0;
    for (char* p = str; *p != '\0'; ++p) {
        ++length;
    }
    return length;
}

/**
 * @brief Bildet die Konkatenation der beiden übergebenen char-Arrays und gibt diese als char-Pointer (?) zurück. 
 * 
 * @param str1 Erstes Char-Array
 * @param str2 Zweites Char-Array
 * @param ergebnis Rückgabe-Pointer
 * @return char* Pointer (?) auf die Konkatenation beider char-Arrays
 */
char* cat (char* str1, char* str2, char* konkartination) {
    unsigned str1Length = getCharLength(str1);
    unsigned str2Length = getCharLength(str2);

    for (unsigned i = 0; i < str1Length+str2Length; ++i) {
        konkartination[i] = (i < str1Length ) ? str1[i] : str2[i - str1Length];
    }
    konkartination[str1Length + str2Length] = '\0';
    return konkartination;
}

int main () {
    char str1[] = "Hello, World!"; // length = 13
    cout << "getCharLength(\"Hello, World!\") = " << getCharLength(str1) << endl;

    char str2[] = "Bye, ";
    char str3[] = "World!";
    char konkartination[getCharLength(str2) + getCharLength(str3) + 1];
    cat(str2, str3, konkartination); 
    cout << konkartination << endl; 

    return 0; // kryptischer Fehler von valgrind?
}