/**
 * @file aufgabe02.cpp
 * @author Gießel, Franjo (Franjo.Giessel@smail.HS-Bremerhaven.de)
 * @brief Schreiben Sie die Funktion rev, die einen String (char-Pointer) übergeben bekommt und einen neuen String (char-Pointer) zurückliefert, der das gespiegelte Wort enthält. Vermeiden Sie vordefinierten Funktionen wie strlen, cpy.
 * @version 0.1
 * @date 2022-05-21
 * 
 * @copyright Copyright (c) 2022
 * 
 */

#include <iostream>
using namespace std;

/**
 * @brief Get the length of the char-array.
 * 
 * @param str char-array
 * @return unsigned Length of the char-array
 */
unsigned getCharLength (char* str) {
    unsigned length = 0;
    for (char* p = str; *p != '\0'; ++p) {
        ++length;
    }
    return length;
}

/**
 * @brief Gibt das übergebene char-Array in umgekehrter Reihenfolge zurück
 * 
 * @param str Zu drehendes char-Array
 * @param ergebnis Pointer auf das Ergebnis-char-Array (muss dieselbe Länge wie str haben!)
 * @return char* Umgekehrtes char-Array
 */
char* rev (char* str, char* reverse) {
    unsigned strLength = getCharLength(str);

    for (unsigned i = 0; i < strLength; ++i) {
        reverse[i] = str[strLength-i-1];
    }
    reverse[getCharLength(reverse)] = '\0';
    return reverse;
}

int main () {
    char str[] = "Hello, World!";
    char reverse[getCharLength(str) + 1];
    rev(str, reverse); 
    cout << reverse << endl; 

    return 0;
}