/**
 * @file aufgabe03.cpp
 * @author Gießel, Franjo (Franjo.Giessel@smail.HS-Bremerhaven.de)
 * @brief Schreiben Sie die Funktion pal, die einen String (char-Pointer) übergeben bekommt und einen booleschen Wert zurückliefert. Der Wert ist true, genau dann wenn das übergebene Wort ein Palindrom ist. Vermeiden Sie vordefinierten Funktionen wie strlen, cpy. 

 * @version 0.1
 * @date 2022-05-21
 * 
 * @copyright Copyright (c) 2022
 * 
 */

#include <iostream>
using namespace std;

/**
 * @brief Get the length of the char-array.
 * 
 * @param str char-array
 * @return unsigned Length of the char-array
 */
unsigned getCharLength (char* str) {
    unsigned length = 0;
    for (; *str; ++str, ++length);
    return length;
}

/**
 * @brief Prüft, ob übergebenes char-Array ein Palindrom ist.
 * 
 * @param str Zu prüfendes char-Array
 * @return true char-Array ist ein Palindrom
 * @return false char-Array ist kein Palindrom
 */
bool pal (char* str) {
    unsigned strLength = getCharLength(str);

    for (unsigned i = 0; i < strLength/2; ++i) {
        if (str[i] != str[strLength-i-1]) {
            return false;
        }
    }
    return true;
}

int main () {
    char str0[] = "lagerregal"; 
    cout << "pal(\"" << str0 << "\") = " << (pal(str0) ? "true" : "false") << endl; 

    char str1[] = "Hello, World!"; 
    cout << "pal(\"" << str1 << "\") = " << (pal(str1) ? "true" : "false") << endl; 

    return 0; // Kein valgrind-Fehler 🎃
}