#include <iostream>

using namespace std;

struct Heap {
    unsigned m_iNext;
    int* m_Keys;

    Heap (unsigned uiSize) {
        m_iNext = 0;
        m_Keys = new int[uiSize];
    }

    Heap (unsigned uiSize, int* field) {
        m_iNext = 0;
        m_Keys = field;
    }

    ~Heap () {
        delete[] m_Keys;
    }

    void downheap (unsigned uEnd, unsigned uIndex) {
        int k = m_Keys[uIndex];
        while (uIndex < uEnd / 2) {
            unsigned uSon = 2 * uIndex + 1;
            if (uSon < uEnd - 1 && m_Keys[uSon] < m_Keys[uSon + 1])
                ++uSon;
            if (!(k < m_Keys[uSon]))
                break;
            m_Keys[uIndex] = m_Keys[uSon];
            uIndex = uSon;
        }
        m_Keys[uIndex] = k;
    }
};

typedef void (*fillFunction) (int* field, unsigned size);

void singleRunHeap (unsigned i, fillFunction f) {
    int* field = new int[i];
        (*f)(field, i);
        // printArray(field, i);
        sclk::time_point startTime = sclk::now();

        Heap heap(i, field);
        for (unsigned j = ((i - 1) - 1) / 2; i--; ) {
            heap.downheap(i, j);
        }
        for (unsigned j = i - 1; j--; ) {
            swap(heap.m_Keys, 0, i);
            heap.downheap(i, 0);
        }

        sclk::time_point endTime = sclk::now();
        // printArray(field, i);

        sclk::duration durationTime = endTime - startTime;
        cout << "Dauer für Heapsort Größe " << i << " in µSec.: " << chrono::duration_cast<chrono::microseconds>(durationTime).count() << endl;   
        delete[] field;
}

int main () {
}